<?php

$wgExtensionCredits['parserhook'][] = array(
	'path'            => __FILE__,
	'name'            => 'UnstrExtSearch',
	'version'         => '0.0.1',
	'descriptionmsg'  => 'stringfunctions-desc',
	'author'          => 'MF',
	'url'             => 'http://google.de?q=unstrExtSearch',
);

$dir = dirname( __FILE__ ) . '/';
#$wgExtensionMessagesFiles['Quark'] = $dir . 'Quark.i18n.php';

$wgExtensionFunctions[] = 'wfUnstrExtSearch';


## include js and css (new version) ##
$wgResourceModules['ext.expandcollapsed'] = array(
        // JavaScript and CSS styles. To combine multiple files, just list them as an array.
        'scripts' => 'js/expandcollapsed.js',
	// 'styles' => 'css/expandcollapsed.css',
 
        // When your module is loaded, these messages will be available through mw.msg()
        'messages' =>  'myextension-unstructured-external-search',
	'dependencies' => array( 'jquery' ),
 	
        // You need to declare the base path of the file paths in 'scripts' and 'styles'
        'localBasePath' => dirname( __FILE__ ),
        // ... and the base from from the browser as well. For extensions this is made easy,
        // you can use the 'remoteExtPath' property to declare it relative to where the wiki
        // has $wgExtensionAssetsPath configured:
        'remoteExtPath' => 'expandcollapsed',
	// optional
//'position' => 'top',
);

$wgResourceModules['ext.expandcollapsedcss'] = array(
        // JavaScript and CSS styles. To combine multiple files, just list them as an array.
        'styles' => 'css/expandcollapsed.css',
 
        // When your module is loaded, these messages will be available through mw.msg()
        'messages' =>  'myextension-unstructured-external-search-css',
 
        // You need to declare the base path of the file paths in 'scripts' and 'styles'
        'localBasePath' => dirname( __FILE__ ),
        // ... and the base from from the browser as well. For extensions this is made easy,
        // you can use the 'remoteExtPath' property to declare it relative to where the wiki
        // has $wgExtensionAssetsPath configured:
        'remoteExtPath' => 'expandcollapsedcss',
	// optional
);

## include another js ##
$wgResourceModules['ext.useMarkedText'] = array(
        // JavaScript and CSS styles. To combine multiple files, just list them as an array.
        'scripts' => 'js/useMarkedText.js',
 
        // When your module is loaded, these messages will be available through mw.msg()
        'messages' =>  'myextension-unstructured-external-search...',
	'dependencies' => array( 'jquery' ),
 	
        // You need to declare the base path of the file paths in 'scripts' and 'styles'
        'localBasePath' => dirname( __FILE__ ),
        // ... and the base from from the browser as well. For extensions this is made easy,
        // you can use the 'remoteExtPath' property to declare it relative to where the wiki
        // has $wgExtensionAssetsPath configured:
        'remoteExtPath' => 'useMarkedText'
);

## ##


$wgHooks['LanguageGetMagic'][] = 'wfUnstrExtSearchLanguageGetMagic';

function wfUnstrExtSearch ( ) {
	global $wgParser, $wgExtUnstrExtSearch;
	$wgExtUnstrExtSearch = new ExtUnstrExtSearch ( );
	$wgParser->setFunctionHook('unstrExtSearch',      array(&$wgExtUnstrExtSearch,'unstrExtSearch'      ));	
}

function wfUnstrExtSearchLanguageGetMagic( &$magicWords, $langCode = "en" ) {
	switch ( $langCode ) {
	default:
		$magicWords['unstrExtSearch']          = array ( 0, 'unstrExtSearch' );
	}
	return true;
}




class ExtUnstrExtSearch {


	function unstrExtSearch ( &$parser, $querystring = '', $source = '') {

	$output = '';

############# (old) BING SEARCH ############# (old) BING SEARCH ############# BING SEARCH ############# BING SEARCH ############# BING SEARCH ############# BING SEARCH 
if(strcasecmp($source, 'bing') == 0) {
global $wgOut;
    $wgOut -> addModules('ext.expandcollapsed');
    $wgOut -> addModules('ext.expandcollapsedcss');

## INSERT JAVASCRIPT/JS IN HEADER DONE BY Loader (wgResourceModules), see above

	$APPID = 'DE179D1721304CA97BE7B11E982EA7003AE5988E';
	$request = 'http://api.bing.net/json.aspx?Appid=' . $APPID . '&Options=EnableHighlighting&sources=web&Web.count=30&query=' . $querystring;
	# . urlencode($_POST["searchBox"])

	$response = file_get_contents($request);
	$jsonobj = json_decode($response);
	$output = '';

	$resultnr = 0;

	foreach($jsonobj->SearchResponse->Web->Results as $value)
	{
		$resultnr++;
		if($resultnr == 1) {
			$output .= '<ul ID="resultList"><p>Results for query "' . $querystring . '" using ' . $source . '</p>';
		}	
		if($resultnr == 11) {
			$output .= '<br /><li class="additionalresultlist">Additional results<ul>';
		}

			$output .= '<li class="resultlistitem">';
			$output .= '<p><font size="3">[' . $value->Url . ' ' . $value->Title . ']</font></p>';
			$output .= '<p><font size="2">' . $value->Description . '</font></p>';
			$output .= '</li>';

	}
	if($resultnr > 10) { // addit. result list built -> close
		$output .= '</ul></li>';
	}

	if($resultnr > 0) {
		$output .= '</ul>';
	}
	else{
		$output .= 'nothing found.';
	}

	return $output;

} // end of bing

############# GOOGLE SEARCH ############# GOOGLE SEARCH ############# GOOGLE SEARCH ############# GOOGLE SEARCH ############# GOOGLE SEARCH #############
// 'google' as parameter given, so let's google...
if(strcasecmp($source, 'google') == 0) {
	global $wgUser;
	global $wgOut;
	$wgOut -> addModules('ext.useMarkedText');

	// Google CSE API v1 URI (query)
	// API key and CSE key already hard coded (inserted)
	$request = 'https://www.googleapis.com/customsearch/v1?key=AIzaSyBi7XjVCKkM9rN1jtjH_PDKG8-8kc7vgKQ&cx=012948760753720811201:s4gol2x-day&callback=jsonp_cse&q=' . $querystring;
	$response = file_get_contents($request);
	$jsonobj = json_decode($response);


#########Very easy example of json decoding:
##
##$json = '{"foo-bar": 12345}';
##
##$obj = json_decode($json);
##print $obj->{'foo-bar'}; // 12345
##
############
// temporär mitausgeben:
	$output .= $jsonobj->queries->request->totalResults . ' __ ' . sizeof($jsonobj) . '__';

if (!empty($jsonobj->items)) {
	// processing single result items of Google search
	foreach($jsonobj->items as $searchresultitem)
	{
		$output .= '<div class="resultlistitem">
	      <p><font size="3">[' . $searchresultitem->link . ' ' . $searchresultitem->htmlTitle . ']</font></p>
	      <p><font size="2">' . $searchresultitem->htmlSnippet . '</font></p>
	      <p>' . $searchresultitem->htmlFormattedUrl . '</p></div>';

	}
}
else{
	$output .= 'Could not find any result items.';	
	}

## temporär 1:
 return 'query: ' . $querystring . '  ...:' . $output;
	
/**
///// ///// edit/create new Wiki page ///// /////

    $articleTitle = Title::newFromText( "Google-Resultpage-" . $querystring );
    if (!$articleTitle->exists() )
    {
	$article = new Article( $articleTitle );
                if ( !$article ) {
                        $this->error = 'createPage: Article not found "' . $this->title->getPrefixedDBkey() . '"';
                        wfProfileOut( __METHOD__ );
                        return false;
                }

        //$page_text = $this->params['page_text'];
	$page_text = $output;        
	// change global $wgUser variable to the one
        // specified by the job only for the extent of this
        // replacement
        // already defined above:
	// global $wgUser;
        $actual_user = $wgUser;
	// added afterwards (after woogle installation)
	$params['user_id'] = $wgUser->getId();
        // change from $wgUser = User::newFromId( $this->params['user_id'] ); to
	$wgUser = User::newFromId( $params['user_id'] );
        $edit_summary = ''; // $this->params['edit_summary'];
        $article->doEdit( $page_text, $edit_summary ); 
   }
   else
   {
	return '<br /><b>Already queried! See: [[Google-Resultpage-'. $querystring .']]</b>';

    }

///// /////  end edit new Wiki page ///// ///// 

	// old: return $output;

	return 'Suche wurde durchgeführt.';// Zu den Ergebnissen: [[' . $querystring . ']]';
## temporär 2:
**/
} // end of google search

else {
	return array("source not defined! [[test::ok]]", 'noparse' => false);
}

} // end of function

	
##################

/**
	function unstrExtSearch2 ( &$parser, $inStr = '' ) {
$url = 'http://ajax.googleapis.com/ajax/services/search/web?rsz=large&v=1.0&q=' . urlencode('site:' . $_SERVER['HTTP_HOST'] . ' ' . $_POST['searchquery']);
return $url;
// use PHP's curl library to pull Google's search results (curl library info @ http://us.php.net/curl)

$ch = curl_init();
curl_setopt($ch, CURLOPT_URL, $url);
curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
curl_setopt($ch, CURLOPT_REFERER, $_SERVER['REQUEST_URI']);
$body = curl_exec($ch);
curl_close($ch);

// now $body is the JSON encoded results. We need to decode them. I used the JSON decoder @ http://mike.teczno.com/JSON/JSON.phps

$json = new Services_JSON();
$json = $json->decode($body);

// now $json is an object of Google's search results and we need to iterate through it.

foreach(json->responseData->results as $searchresult)
{
  if($searchresult->GsearchResultClass == 'GwebSearch')
  {
    echo '
    <div class="searchresult">
      <h3><a href="' . $searchresult->unescapedUrl . '">' . $searchresult->titleNoFormatting . '</a></h3>
      <p>' . $searchresult->content . '</p>
      <p>' . $searchresult->visibleUrl . '</p>
    </div>';
  }
}

}

**/


##########################
/**
         protected function includeJS() {
                 SMWOutputs::requireHeadItem( SMW_HEADER_STYLE );
 
                 // MediaWiki 1.17 introduces the Resource Loader.
                 $realFunction = array( 'SMWOutputs', 'requireResource' );
                 if ( defined( 'MW_SUPPORTS_RESOURCE_MODULES' ) && is_callable( $realFunction ) ) {
                         SMWOutputs::requireResource( 'ext.srf.timeline' );
                 }
                 else {
                         global $srfgScriptPath;
                         SMWOutputs::requireHeadItem(
                                 'smw_tlhelper',
                                 '<script type="text/javascript" src="' . $srfgScriptPath . 
                                         '/Timeline/SRF_timeline.js"></script>'
                         );
                         SMWOutputs::requireHeadItem(
                                 'smw_tl',
                                 '<script type="text/javascript" src="' . $srfgScriptPath . 
                                         '/Timeline/SimileTimeline/timeline-api.js"></script>'
                         );                      
                 }               
         }
	}

**/

}
